//+------------------------------------------------------------------+
//|                                                      All ADX.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright   "mladen"
#property link        ""
#define indicatorName "All"
//----

//---- input parameters

#property indicator_separate_window

#property indicator_minimum 0
#property indicator_maximum 100
#property  indicator_buffers 2
#property  indicator_color1  Blue
extern int F=24;
extern double k=6;
extern double L_adx=23;


//---- indicator buffers


double     MaBuffer[];
double     XBuffer[];

extern bool   showHigherTimeframes=false;
extern int    barsPerTimeFrame    =10;
extern bool   shiftRight          =False;
extern color  txtColor            =Silver;
extern color  separatorColor      =DimGray;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];

//----
string shortName;
string labelsShort[] ={"M1","M5","M15","M30","H1","H4","D1"};
string labelsLong[]  ={"M15","M30","H1","H4","D1","W1","MN1"};
string labels[];
int    periodsShort[]={PERIOD_M1,PERIOD_M5,PERIOD_M15,PERIOD_M30,PERIOD_H1,PERIOD_H4,PERIOD_D1};
int    periodsLong[] ={PERIOD_M15,PERIOD_M30,PERIOD_H1,PERIOD_H4,PERIOD_D1,PERIOD_W1,PERIOD_MN1};
int    periods[];
int    Shift;
double minValue;
double maxValue;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_LINE,EMPTY,2);
   SetIndexDrawBegin(0,F);
   IndicatorDigits(Digits+1);
   SetIndexBuffer(0,XBuffer);
   SetIndexBuffer(1,MaBuffer);
   IndicatorShortName("All");
   SetIndexLabel(0,"X");
   SetLevelValue(0,61.8);
   SetLevelValue(1,-61.8);
   SetLevelStyle(STYLE_DOT,1,CLR_NONE);
   return(0);
   //----
   if (shiftRight) Shift=1;
   else            Shift=0;
   SetIndexShift(0,Shift*(barsPerTimeFrame+1));
   SetIndexShift(1,Shift*(barsPerTimeFrame+1));
   SetIndexShift(2,Shift*(barsPerTimeFrame+1));
   //----
   SetIndexLabel(0,"ALL");
   SetIndexLabel(1,"+DI");
   SetIndexLabel(2,"-DI");
  
   IndicatorShortName(shortName);
     if (showHigherTimeframes) 
     {
      ArrayCopy(labels,labelsLong);
      ArrayCopy(periods,periodsLong);
     }
     else  
     {
      ArrayCopy(labels,labelsShort);
      ArrayCopy(periods,periodsShort);
     }
   //----
   for(int i=1;i<7;i++)
      if (Period()==periods[i])
        {
         string tmpLbl=labels[i];
         int    tmpPer=periods[i];
         //----
         for(int t=i ;t>0; t--)
           {
            labels[t] =labels[t-1];
            periods[t]=periods[t-1];
           }
         labels[0] =tmpLbl;
         periods[0]=tmpPer;
        }
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   for(int l=0;l<7;l++)
     {
      ObjectDelete(indicatorName+l);
      ObjectDelete(indicatorName+l+1);
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   string on;
   int    wn=WindowFind(shortName);
   int    t=0;

   //----
   minValue= 999999;
   maxValue=-999999;
   for(int p=0; p<7;p++)
     {
      for(int i=0; i<barsPerTimeFrame;i++,t++)
        {
        
        MaBuffer[t]=iCustom(NULL,0,"CMX",F,PRICE_CLOSE,0,i);
             checkMinMax(t);
         
        }
      MaBuffer[t] =EMPTY_VALUE;
 
      t+=1;
 
      //----
      on=indicatorName+p;
      if(ObjectFind(on)==-1)
         ObjectCreate(on,OBJ_TREND,wn,0,0);
      ObjectSet(on,OBJPROP_TIME1,myTime(t-Shift*(barsPerTimeFrame+1)-1));
      ObjectSet(on,OBJPROP_TIME2,myTime(t-Shift*(barsPerTimeFrame+1)-1));
      ObjectSet(on,OBJPROP_COLOR ,separatorColor);
      ObjectSet(on,OBJPROP_WIDTH ,2);
      on=indicatorName+p+1;
      if(ObjectFind(on)==-1)
         ObjectCreate(on,OBJ_TEXT,wn,0,0);
      ObjectSet(on,OBJPROP_TIME1,myTime(t-Shift*(barsPerTimeFrame+1)-6));
      ObjectSetText(on,labels[p],9,"Arial",txtColor);
     }
   for(p=0; p<7;p++)
     {
      on=indicatorName+p;
      ObjectSet(on,OBJPROP_PRICE1,minValue*1.05);
      ObjectSet(on,OBJPROP_PRICE2,maxValue);
      on=indicatorName+p+1;
      ObjectSet(on,OBJPROP_PRICE1,(minValue+maxValue)/2);
     }
   //----
   for(p=0; p<7;p++)
     {
      on=indicatorName+p;
      ObjectSet(on,OBJPROP_PRICE1,maxValue);
      ObjectSet(on,OBJPROP_PRICE2,minValue);
      on=indicatorName+p+1;
      ObjectSet(on,OBJPROP_PRICE1,maxValue);
     }
   //----
   SetIndexDrawBegin(0,Bars-t);
 //  SetIndexDrawBegin(1,Bars-i);
  // SetIndexDrawBegin(2,Bars-k);
   return(0);
  }
//+------------------------------------------------------------------+
//+ Custom functions and procedures                                  +
//+------------------------------------------------------------------+
void checkMinMax(int shift)
  {
   double tmpMin;
   double tmpMax;
//----
 
  
   tmpMin=MathMin(MaBuffer[shift],XBuffer[shift]);
   tmpMin=MathMin(MaBuffer[shift],tmpMin);
   tmpMax=MathMax(MaBuffer[shift],XBuffer[shift]);
  tmpMax=MathMax(MaBuffer[shift],tmpMax);
   minValue=MathMin(tmpMin,minValue);
   maxValue=MathMax(tmpMax,maxValue);
   
    }
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int myTime(int a)
  {
   if(a<0)
      return(Time[0]+Period()*60*MathAbs(a));
   else  return(Time[a]);
  }
//+------------------------------------------------------------------+